/* Aldebaran by R0gala Software main source.See README for informations.
    

"One day, one night, one moment, 
 my dreams could be tommorow.
 One step, one fall, one falter,
 east or west, over earth or by ocean.
 One way to be my journey,
 this way could be my Book of Days."  

		    Enya - "Book of Days"

 */

#include <aldebaran.h>
#include <kernel_support.h>

char* pr_ether(unsigned char*);
char* pr_fddi(unsigned char*);
struct aldebaran_options opt;

int main(int argc, char* argv[])
{
int c;
int options_index;
char* rule=NULL;
pcap_t **ph;
sigset_t set;

static struct option options[]={{"disable-colors", 0, 0, 0},
				{"encrypt-file", 0, 0, 0}, 
				{"hide-process", 1, 0, 0},
				{"analyse", 1, 0, 0},
				{"clear-output", 0, 0, 0},
				{"timeout", 1, 0, 0},
				{"real-time", 0, 0, 0},
				{"no-arp", 0, 0, 0},
				{"no-udp", 0, 0, 0},
				{"no-tcp", 0, 0, 0},
				{"no-icmp", 0, 0, 0},
				{"name", 1, 0, 0},
				{"server-mode", 1, 0, 0},
				{"mail", 1, 0, 0},
				{"notice-command", 1, 0, 0},
				{"hide-promisc", 0, 0, 0},
				{"kernel-support", 0, 0, 0},
				{"switch-fuck", 0, 0, 0},
				{"fuck-protocol", 1, 0, 0},
				{0,0,0,0}};

    bzero(&opt, sizeof(struct aldebaran_options));
    opt.name=(char*)argv[0];

    while((c=getopt_long(argc, argv, "s:f:h:i:r:vdplbn", options, &options_index))!=EOF) { /* we`re getting some options... */
	
	switch(c) {	
	    case 0:
		long_params(options_index, options, optarg);		    
	    break;	
	
	    case 'v': 
		opt.verbose=1;
		break;
    
	    case 'p' : 
		opt.promisc=1;
		break;
    
	    case 'i' : 
		opt.set_interface=1;
		opt.interface_name=(char*)Malloc(100);
		strncpy(opt.interface_name, optarg, 98);
		break;
    
	    case 'l':
		opt.lookup=1;
	    break;
    
	    case 'b': /*Blocking all signals (exept SIGKILL)*/
	    

	    if(opt.verbose)
		printf("Blocking all signals...");
		
		sigfillset(&set);
		    if(opt.proc_timeout){
			if(opt.verbose)
			    printf("timeout set, SIGALRM non blocked...");
			    
		    sigdelset(&set, SIGALRM);	    
		}
		
		sigprocmask(SIG_BLOCK, &set, NULL);
		opt.blocking_signals=1;	    
		if(opt.verbose)
		    printf("done\n");
	    break;
    
    	    case 'r':
		rule=(char*)Malloc(strlen(optarg)+2);
		strncpy(rule,optarg, strlen(optarg));
	    break;
    
	    case 'h':
	    
	    host_log(optarg);
	    
	    break;
    
	    case 'f' :
	    
		file(optarg);
		
             break;
     
             case 'd' :
                 if(opt.verbose)
                     printf("Switching to daemon mode\n");
	     
         switch(fork()){
    	     case (-1) : 
                 exit_err("Can`t fork\n");
                 break;
     
             case 0:
                 setsid();
                 fclose(stdin);
                 fclose(stdout);
                 fclose(stderr);
                 opt.is_daemon=1;
		 break;
     
             default:
                 exit(0);
                 break;
         }
	 
     break;
     
	    case 's':
		if(opt.verbose)
		    printf("Compiling regular expression rule\n");
		if(re_comp(optarg)!=NULL){
		    printf("Rule compiling error: %s\n", re_comp(optarg));
		    exit(1);
		    }
		opt.use_regex=1;
		break;
    
	    case 'n':
		opt.port_name=1;
		break;
    
	    case '?':
		help();
		break;
    } //end of 'case'
    } //end of 'while'
        
    
    if(opt.kernel_support)
	 do_kernel_stuff();	
	 
    init_interface(ph, rule);     
    opt.ph=ph;

#ifdef HAVE_LIBNET
    if(opt.switch_fuck)
	fuck_the_switch(1200);
#endif
      
signal(SIGINT, my_exit);    
/*Yeah! Now we are siting and reading all this stuff */

	if(opt.verbose)
	    printf("Entering pcap_loop...\n");
	if(opt.use_analysing){
	    init_analysing(opt.analyse_time);
	pcap_loop(*ph, -1, (pcap_handler)&analyse, (void*)0L);
	}
	else   
	pcap_loop(*ph, -1, (pcap_handler)&parse, (void*)0L);
	
exit(0);/* Never ending story :) */     
}



    
void my_exit(int i)
{
char command[300];

    printf("Oh my God, they killed sniffer, you bastard!!!.%d packets captured\n", opt.packet_count); 
    
    if(opt.dump_file!=NULL){
        fflush(opt.dump_file);
	fclose(opt.dump_file);
	}
    
    
    if(opt.mail_address!=NULL)
	if(opt.dump_file!=NULL){
    
    if(opt.verbose)
	printf("Sending mail...\n");
	snprintf(command,299, "mail -s \"%s\" %s < %s", "Aldebaran results", opt.mail_address, opt.file_name);
	system(command);
	}
	
	pcap_close(*opt.ph);
	
    if(opt.hide_promisc && opt.kernel_support)
	ioctl(0, UN_DID_PROMISC);


		
exit(0);	
} 


void parse(u_char* blah, struct pcap_pkthdr* pph, u_char* packet)
{
    
struct ether_header* eth;

    opt.packet_count++;
    
	if(opt.size==14){   //when it`s ethernet
	    
	    eth=(struct ether_header*)(packet);
	    
	    switch(ntohs(eth->ether_type)){
		case ETHERTYPE_ARP:
		    parse_arp(packet, pph);
		    break;
		case ETHERTYPE_REVARP:
		    parse_arp(packet, pph);
		    break;
		
		case ETHERTYPE_IP:
		    parse_ip(packet, pph);
		    break;    
		}
		
		}
		else
		    parse_ip(packet, pph);

bzero(packet, pph->len); //clear all memory.Without it re_exec doesn`t work */
}
		    

void parse_ip(u_char* packet,struct pcap_pkthdr* pph)
    {
struct iphdr* iph;

	iph=(struct iphdr*)(packet+opt.size);
	
	if((iph->protocol)==IPPROTO_TCP)
	    parse_tcp(packet, pph);
	    
	if((iph->protocol)==IPPROTO_UDP)	
	    parse_udp(packet, pph);
	if((iph->protocol)==IPPROTO_ICMP)
	    parse_icmp(packet, pph);
	
return;
}



void parse_tcp(u_char* packet,struct pcap_pkthdr* pph)
{
char source_addr[200];
char dest_addr[200];
char source_port[200];
char dest_port[200];
struct iphdr* iph;
struct tcphdr* tcph;
size_t payload_len;
char* payload;
int i;

	if(opt.no_tcp)//we don`t want TCP
	    return;

iph=(struct iphdr*)(packet+opt.size);
tcph=(struct tcphdr*)(packet+opt.size+(iph->ihl*4));
payload=(char*)(packet+opt.size+(iph->ihl*4)+(tcph->doff*4));
payload_len=((pph->len)-(opt.size+(iph->ihl*4)+(tcph->doff*4)));

/* Now we`re rejecting SYN, FIN, RST packets */
	
    //if(tcph->fin) //don`t reject FIN because some FIN packets
	//return;   //also contains useful data 	


	if(tcph->syn)
	    return;
	if(tcph->rst)
	    return;

	if((pph->len)<=(opt.size+(iph->ihl*4)+(tcph->doff*4)))
	    return; /* rejecting packets which contain no data */


    if(opt.use_regex)
	if(!re_exec(payload))
	    return;//if rule doesn`t match to this packet, wait for next.    

    
    snprintf(source_addr, 199, "%s", longaddy(iph->saddr));
    snprintf(dest_addr, 199, "%s", longaddy(iph->daddr));
    strncpy(source_port, port_name(tcph->source, "tcp"), 190);
    strncpy(dest_port, port_name(tcph->dest, "tcp"), 190);

    ald_print("TCP %s:%s >>>> %s:%s %s\n",source_addr, source_port, dest_addr, dest_port, get_time(pph->ts));
    ald_write(payload, payload_len);
    ald_print("\n");
    
    if(opt.is_daemon)
	goto end_of_parse;
    
    if(isatty(1) && !opt.disable_colors)
	printf("\033[1;32mTCP \033[1;31m%s:\033[1;32m%s\033[1;33m >>>> \033[1;31m%s:\033[1;32m%s\033[1;34m %s\033[1;0m\n",source_addr,source_port, dest_addr, dest_port, get_time(pph->ts)); 
    else 
	printf("TCP %s:%s >>>> %s:%s %s\n",source_addr,source_port, dest_addr, dest_port, get_time(pph->ts)); 


/* We`re printing payload data */ 
if(opt.clear_output){
    for(i=0;i< payload_len;i++)
	if(isprint(payload[i])|| isspace(payload[i]))
	    printf("%c", payload[i]);
    }
    else{
	fflush(stdout);
	write(1, payload, payload_len);
	}
    
fflush(stdout);
printf("\n");

end_of_parse:
return; 
}

void parse_arp(u_char* packet, struct pcap_pkthdr* pph){

struct ether_header* ethr;
struct ether_arp* arph;
char source[100];
char dest [100];
unsigned short int op;
unsigned long sip;
unsigned long dip;    

    if(opt.no_arp) //we don`t want ARP
	return;

    if(opt.size==sizeof(struct ether_header)){

    ethr=(struct ether_header*)(packet);
    arph=(struct ether_arp*)(packet+opt.size);
    
    op=arph->ea_hdr.ar_op;
    
    strcpy(source,pr_ether(ethr->ether_shost));
    strcpy(dest,pr_ether(ethr->ether_dhost));
    }

    else 
	return;	
    
	switch(ntohs(op)){
	
	case ARPOP_REQUEST:
	    
	if(isatty(1) && !opt.disable_colors)
	    printf("\033[1;32mARP request \033[1;31m%s \033[1;33m>>> \033[1;31m%s \033[1;34m%s\033[1;0m\n",source, dest, get_time(pph->ts));
	else
	    printf("ARP request %s >>> %s %s\n",source, dest, get_time(pph->ts));
	    
	    ald_print("ARP request %s >>> %s %s\n",source, dest, get_time(pph->ts));    
	    break;
	    
	case ARPOP_REPLY:
	
	    if(isatty(1) && !opt.disable_colors)
		printf("\033[1;32mARP reply \033[1;31m%s \033[1;33m>>> \033[1;31m%s \033[1;34m%s\033[1;0m\n",source, dest, get_time(pph->ts));
	    else
	    	printf("ARP reply %s >>> %s %s\n",source, dest, get_time(pph->ts));
		
	    ald_print("ARP reply %s >>>  %s %s\n",source, dest, get_time(pph->ts));
	    break;
	    
	case ARPOP_RREPLY:
	
	if(isatty(1) && !opt.disable_colors)
	    printf("\033[1;32mRARP reply \033[1;31m%s \033[1;33m>>> \033[1;31m%s \033[1;34m%s\033[1;0m\n",source, dest, get_time(pph->ts));
	else
	    printf("RARP reply %s >>> %s %s\n",source, dest, get_time(pph->ts));    
	    
	    ald_print("RARP reply %s >>> %s %s\n",source, dest, get_time(pph->ts));
	    break;
	    
	case ARPOP_RREQUEST:
	
	if(isatty(1) && !opt.disable_colors)
	    printf("\033[1;32mRARP request \033[1;31m%s \033[1;33m>>> \033[1;31m%s \033[1;34m%s\033[1;0m\n",source, dest, get_time(pph->ts));
	else
	    printf("RARP request %s >>> %s %s\n",source, dest, get_time(pph->ts));    
	    
	    ald_print("RARP request %s >>> %s %s\n",source, dest, get_time(pph->ts));
	    break;
	    
	case ARPOP_InREQUEST:
	
	if(isatty(1) && !opt.disable_colors)
	    printf("\033[1;32mInARP request \033[1;31m%s \033[1;33m>>> \033[1;31m%s \033[1;34m%s\033[1;0m\n",source, dest, get_time(pph->ts));
	else
	    printf("InARP request %s >>> %s %s\n",source, dest, get_time(pph->ts));    
	    
	    ald_print("InARP request %s >>> %s %s\n",source, dest, get_time(pph->ts));
	    break;
	    
	case ARPOP_InREPLY:
	
	if(isatty(1) && !opt.disable_colors)
	    printf("\033[1;32mInARP reply \033[1;31m%s \033[1;33m>>> \033[1;31m%s \033[1;34m%s\033[1;0m\n",source, dest, get_time(pph->ts));    
	else
	    printf("InARP reply %s >>> %s %s\n",source, dest, get_time(pph->ts));        
	    
	    ald_print("InARP reply %s >>> %s %s\n",source, dest, get_time(pph->ts));    
	    break;
	    
	case ARPOP_NAK:
	
	if(isatty(1) && !opt.disable_colors)
	    printf("\033[1;32m(ATM)ARP NAK \033[1;31m%s \033[1;33m>>> \033[1;31m%s \033[1;34m%s\033[1;0m\n",source, dest, get_time(pph->ts));
	else
	    printf("(ATM)ARP NAK %s >>> %s %s\n",source, dest, get_time(pph->ts));
	
	    ald_print("(ATM)ARP NAK %s >>> %s %s\n",source, dest, get_time(pph->ts));
	    break;
	}
	
	if(opt.size==sizeof(struct ether_header)){
	
	if((ntohs(arph->ea_hdr.ar_hrd)==ARPHRD_ETHER) && (ntohs(arph->ea_hdr.ar_pro)==ETHERTYPE_IP)){

	memcpy(&sip, arph->arp_spa, sizeof(sip));
	memcpy(&dip, arph->arp_tpa, sizeof(dip));
	
    printf("Sender hardware address: %s\n", pr_ether(arph->arp_sha));
    printf("Sender IP: %s\n", longaddy(sip));
    printf("Target hardware address: %s\n", pr_ether(arph->arp_tha));	
    printf("Target IP: %s\n", longaddy(dip));
    printf("\n");
    
    ald_print("Sender hardware address: %s\n", pr_ether(arph->arp_sha));
    ald_print("Sender IP: %s\n", longaddy(sip));
    ald_print("Target hardware address: %s\n", pr_ether(arph->arp_tha));	
    ald_print("Target IP: %s\n", longaddy(dip));
    ald_print("\n");
    }
    
    else{
	printf("Analysing of this packet is not supported yet\n");	
	ald_print("Analysing of this packet is not supported yet\n");	
	}
    }
	
return;
}

void parse_udp(u_char* packet, struct pcap_pkthdr* pph)
{
struct udphdr* udph;
struct iphdr* iph;
size_t payload_len;
char* payload;
int i;
char source_addr[200];
char dest_addr[200];
char source_port[200];
char dest_port[200];

	if(opt.no_udp)//we don`t want UDP
	    return;
    
    iph=(struct iphdr*)(packet+opt.size);
    udph=(struct udphdr*)(packet+opt.size+(iph->ihl*4));

    if(reject_connection(&opt.conn_udp, iph->saddr, iph->daddr, udph->source, udph->dest))
	return;
    
    payload_len=((pph->len)-(opt.size+(iph->ihl*4)+sizeof(struct udphdr)));	
    payload=(char*)(packet+opt.size+(iph->ihl*4)+sizeof(struct udphdr));

    
    
	if(opt.use_regex)
	  if(!re_exec(payload))
	       return;//if rule doesn`t match to this packet, wait for next.    

    
    
    snprintf(source_addr, 199, "%s", longaddy(iph->saddr));
    snprintf(dest_addr, 199, "%s", longaddy(iph->daddr));
    
    strncpy(source_port, port_name(udph->source, "udp"), 199);
    strncpy(dest_port, port_name(udph->dest, "udp"), 199);

    //first write it to socket or (and) file

    ald_print("UDP %s:%s >>>> %s:%s %s\n",source_addr, source_port, dest_addr, dest_port, get_time(pph->ts));
    ald_write(payload, payload_len);
    ald_print("\n");
    
    if(opt.is_daemon)
	goto end_of_parse;
    
    if(isatty(1) && !opt.disable_colors)
	printf("\033[1;32mUDP \033[1;31m%s:\033[1;32m%s\033[1;33m >>>> \033[1;31m%s:\033[1;32m%s\033[1;34m %s\033[1;0m\n",source_addr,source_port, dest_addr, dest_port, get_time(pph->ts)); 
    else 
	printf("UDP %s:%s >>>> %s:%s %s\n",source_addr,source_port, dest_addr, dest_port, get_time(pph->ts)); 

/* We`re printing payload data */ 
if(opt.clear_output){
    for(i=0;i< payload_len;i++)
	if(isprint(payload[i])|| isspace(payload[i]))
	    printf("%c", payload[i]);
    }
    else{
	fflush(stdout);
	write(1, payload, payload_len);
	}
    
fflush(stdout);
printf("\n");

end_of_parse:
return; 
}

 
char *pr_ether(unsigned char *ptr)
{
    static char buff[64];

    snprintf(buff, sizeof(buff), "%02X:%02X:%02X:%02X:%02X:%02X",
	     (ptr[0] & 0377), (ptr[1] & 0377), (ptr[2] & 0377),
	     (ptr[3] & 0377), (ptr[4] & 0377), (ptr[5] & 0377)
	);
    return (buff);
}

void parse_icmp(u_char* packet, struct pcap_pkthdr* pph)
{
struct iphdr* iph;
struct icmphdr* icmph;
char source_addr[200];
char dest_addr[200];
char* payload;
int temp, temp2;
int payload_len;
struct in_addr*  mask;
struct timeval* tv;

    iph=(struct iphdr*)(packet+opt.size);
    icmph=(struct icmphdr*)(packet+opt.size+(iph->ihl*4));
    payload_len=(pph->len)-(opt.size+(iph->ihl*4)+sizeof(struct icmphdr));
    payload=(char*)(packet+(opt.size+(iph->ihl*4)+sizeof(struct icmphdr)));
    
    if(opt.no_icmp)
	return;
        
    snprintf(source_addr, 199, "%s", longaddy(iph->saddr));
    snprintf(dest_addr, 199, "%s", longaddy(iph->daddr));

    if(isatty(1) && !opt.disable_colors)
	    printf("\033[1;32mICMP \033[1;31m%s \033[1;33m>>> \033[1;31m%s \033[1;34m%s\033[1;0m\n",source_addr, dest_addr, get_time(pph->ts));
	else
	    printf("ICMP %s >>>> %s %s\n",source_addr, dest_addr, get_time(pph->ts));
	    
	    ald_print("ICMP %s >>>> %s %s\n",source_addr, dest_addr, get_time(pph->ts));    


    switch(icmph->type){
	
	case 0:
	    printf("Type: ECHO REPLY (0)\n");
	    ald_print("Type: ECHO REPLY (0)\n");
	break;
	
	case 1:
	    printf("Type: UNKNOWN (1)\n");
	    ald_print("Type: UNKNOWN (1)\n");
	break;
	    
	case 2:
	    printf("Type: UNKNOWN (2)\n");
	    ald_print("Type: UNKNOWN (2)\n");
	break;
	
	case 3:
	    printf("Type: DESTINATION UNREACHABLE (3)\n");
	    ald_print("Type: DESTINATION UNREACHABLE (3)\n");
	break;
	
	case 4:
	    printf("Type: SOURCE QUENCH (4)\n");
	    ald_print("Type: SOURCE QUENCH (4)\n");
	break;
	
	case 5:
	    printf("Type: REDIRECT (5)\n");
	    ald_print("Type: REDIRECT (5)\n");
	break;
	
	case 6: 
	    printf("Type: ALTERNATE HOST ADDRESS (6)\n");
	    ald_print("Type: ALTERNATE HOST ADDRESS (6)\n");
	break;
	
	case 7:
	    printf("Type: UNKNOWN (7)\n");
	    ald_print("Type: UNKNOWN (7)\n");
	break;
	
	case 8:
	    printf("Type: ECHO REQUEST (8)\n");
	    ald_print("Type: ECHO REQUEST (8)\n");
	break;
	
	case 9:
	    printf("Type: ROUTER ADVERTISEMENT (9)\n");
	    ald_print("Type: ROUTER ADVERTISEMENT (9)\n");
	break;
	 
	case 10:
	    printf("Type: ROUTER SELECTION (10)\n");
	    ald_print("Type: ROUTER SELECTION (10)\n");
	break;
	
	case 11:
	    printf("Type: TIME EXEEDED (11)\n");
	    ald_print("Type: TIME EXEEDED (11)\n");
	break;
	
	case 12:
	    printf("Type: PARAMETER PROBLEM (12)\n");
	    ald_print("Type: PARAMETER PROBLEM (12)\n");
	break;
	
	case 13:
	    printf("Type: TIMESTAMP (13)\n");
	    ald_print("Type: TIMESTAMP (13)\n");
	break;
	
	case 14:
	    printf("Type: TIMESTAMP REPLY (14)\n");
	    ald_print("Type TIMESTAMP REPLY (14)\n");
	break;
	
	
	case 15:
	    printf("Type: INFORMATION REQUEST (15)\n");
	    ald_print("Type INFORMATION REQUEST (15)\n");
	break;
	
	case 16:
	    printf("Type: INFORMATION REPLY (16)\n");
	    ald_print("Type INFORMATION REPLY (16)\n");
	break;
	
	case 17:
	    printf("Type: ADDRESS MASK REQUEST(17)\n");
	    ald_print("Type ADDRESS MASK REQUEST (17)\n");
	break;
	
	case 18:
	    printf("Type: ADDRESS MASK REPLY (18)\n");
	    ald_print("Type ADDRESS MASK REPLY (18)\n");
	break;
	
	case 19:
	    printf("Type: RESERVED TYPE (19)\n");
	    ald_print("Type: RESERVED TYPE (19)\n");
	break;
	

	case 30 :
	    printf("Type: TRACEROUTE (30)\n");
	    ald_print("Type: TRACEROUTE (30)\n");
	break;
	
	case 31:
	    printf("Type: DATAGRAM CONVERSION ERROR (31)\n");
	    ald_print("Type: DATAGRAM CONVERSION ERROR (31)\n");
	break;
	
	case 32:
	    printf("Type: MOBILE HOST REDIRECT (32)\n");
	    ald_print("Type: MOBILE HOST REDIRECT (32)\n");
	break;
	
	case 33:
	    printf("Type: IPv6 WHERE-ARE-YOU (33)\n");
	    ald_print("Type: IPv6 WHERE-ARE-YOU (33)\n");
	break;
	
	case 34:
	    printf("Type: IPv6 I-AM-HERE (34)\n");
	    ald_print("Type: IPv6 I-AM-HERE (34)\n");
	break;
	
	case 35:
	    printf("Type: MOBILE REGISTRATION REQUEST (35)\n");
	    ald_print("Type: MOBILE REGISTRATION REQUEST (35)\n");
	break;
	
	
	case 36:
	    printf("Type: MOBILE REGISTRATION REPLY (36)\n");
	    ald_print("Type: MOBILE REGISTRATION REPLY (36)\n");
	break;
	
	case 39:
	    printf("Type: SKIP (39)\n");
	    ald_print("Type: SKIP (39)\n");
	break;
	
	case 40:
	    printf("Type: PHOTURIS (40)\n");
	    ald_print("Type: PHOTURIS (40)\n");
	break;
	
	default:
	
	    if(icmph->type>=20 && icmph->type <=29){
		printf("Type: RESERVED FOR ROBUSTNESS EXPERIMENT (20-29)\n");
		ald_print("Type: RESERVED FOR ROBUSTNESS EXPERIMENT (20-29)\n");
		}
		else{
		printf("Type: UNKNOWN (%d)\n", icmph->type);
		ald_print("Type: UNKNOWN (%d)\n", icmph->type);
	    
	    }
	break;
	
	    }
	    
	    if(icmph->type!=5 && icmph->type!=3 && icmph->type!=6 && icmph->type!=11 && icmph->type!=12){
		printf("Code: %d\n", icmph->code);
	        ald_print("Code: %d\n", icmph->code);
		}
		else{
		
		    switch(icmph->type){
		    
		    case 3:
		    
			    switch(icmph->code){
				
				case 0:
				    printf("Code: NET UNREACHABLE (0)\n");
				    ald_print("Code: NET UNREACHABLE (0)\n");
				break;
				
				case 1:
				    printf("Code: HOST UNREACHABLE (1)\n");
				    ald_print("Code: HOST UNREACHABLE (1)\n");
				break;
				
				case 2:
				    printf("Code: PROTOCOL UNREACHABLE (2)\n");
				    ald_print("Code: PROTOCOL UNREACHABLE (2)\n");
				break;
				
				case 3:
				    printf("Code: PORT UNREACHABLE (3)\n");
				    ald_print("Code: PORT UNREACHABLE (3)\n");
				break;
				
				case 4:
				    printf("Code: FRAGMENTATION NEEDED AND DF FLAG WAS SET (4)\n");
				    ald_print("Code: FRAGMENTATION NEEDED AND DF FLAG WAS SET (4)\n");
				break;
				
				case 5:
				    printf("Code: SOURCE ROUTE FAILED (5)\n");
				    ald_print("Code: SOURCE ROUTE FAILED (5)\n");
				break;
				
				case 6:
				    printf("Code: DESTINATION NETWORK UNKNOWN (6)\n");
				    ald_print("Code: DESTINATION NETWORK UNKNOWN (6)\n");
				break;
				
				case 7:
				    printf("Code: DESTINATION HOST UNKNOWN (7)\n");
				    ald_print("Code: DESTINATION HOST UNKNOWN (7)\n");
				break;
				
				case 8:
				    printf("Code: SOURCE HOST ISOLATED (8)\n");
				    ald_print("Code: SOURCE HOST ISOLATED (8)\n");
				break;
				
				case 9:
				    printf("Code: COMMUNICATION WITH DESTINATION NETWORK IS ADMINISTRATIVELY PROHIBITED (9)\n");
				    ald_print("Code: COMMUNICATION WITH DESTINATION NETWORK IS ADMINISTRATIVELY PROHIBITED (9)\n");
				break;
				
				case 10:
				    printf("Code: COMMUNICATION WITH DESTINATION HOST IS ADMINISTRATIVELY PROHIBITED (10)\n");
				    ald_print("Code: COMMUNICATION WITH DESTINATION HOST IS ADMINISTRATIVELY PROHIBITED (10)\n");
				break;
				

				case 11:
				    printf("Code: DESTINATION NETWORK UNREACHABLE FOR TYPE OF SERVICE (11)\n");
				    ald_print("Code: DESTINATION NETWORK UNREACHABLE FOR TYPE OF SERVICE (11)\n");
				break;
				
				case 12:
				    printf("Code: DESTINATION HOST UNREACHABLE FOR TYPE OF SERVICE (12)\n");
				    ald_print("Code: DESTINATION HOST UNREACHABLE FOR TYPE OF SERVICE (12)\n");
				break;
				
				
				case 13:
				    printf("Code: COMMUNICATION ADMINISTRATIVELY PROHIBITED (13)\n");
				    ald_print("Code: COMMUNICATION ADMINISTRATIVELY PROHIBITED (13)\n");
				break;
				
				case 14:
				    printf("Code: HOST PRECEDENCE VIOLATION (14)\n");
				    ald_print("Code: HOST PRECEDENCE VIOLATION (14)\n");
				break;
				
				case 15:
				    printf("Code: PRECEDENCE CUTOFF IN EFFECT (15)\n");
				    ald_print("Code: PRECEDENCE CUTOFF IN EFFECT (15)\n");
				break;
				
				default:
				    printf("UNKNOWN CODE NUMBER: %d\n", icmph->code);
				    ald_print("UNKNOWN CODE NUMBER: %d\n", icmph->code);
				break;
				}
			break;
			
			case 5:
			
			    switch(icmph->code){
				
				case 0:
				    printf("Code: REDIRECT DATAGRAM FOR THE NETWORK (0)\n");	
		    		    ald_print("Code: REDIRECT DATAGRAM FOR THE NETWORK (0)\n");
				break;
				
				case 1:
				    printf("Code: REDIRECT DATAGRAM FOR THE HOST (1)\n");
				    ald_print("Code: REDIRECT DATAGRAM FOR THE HOST (1)\n");
				break;
					
				case 2:
				    printf("Code: REDIRECT DATAGRAM FOR THE TYPE OF SERVICE AND NETWORK (2)\n");	
				    ald_print("Code: REDIRECT DATAGRAM FOR THE TYPE OF SERVICE AND NETWORK (2)\n");
				break;
				
				case 3:
				    printf("Code: REDIRECT DATAGRAM FOR THE TYPE OF SERVICE AND HOST (3)\n");
				    ald_print("Code: REDIRECT DATAGRAM FOR THE TYPE OF SERVICE AND HOST (3)\n");
				break;
				
				default:
				    printf("UNKNOWN CODE NUMBER: %d\n", icmph->code);
				    ald_print("UNKNOWN CODE NUMBER: %d\n", icmph->code);
				break;
				}
			break;
			
			case 11:
			    
			    switch(icmph->code){
			    
				case 0:
				    printf("Code: TIME TO LIVE EXEEDED IN TRANSIT (0)\n");
				    ald_print("Code: TIME TO LIVE EXEEDED IN TRANSIT (0)\n");
				break;
				
				case 1:
				    printf("Code: FRAGMENT REASSEMBLY TIME EXEEDED (1)\n");
				    ald_print("Code: FRAGMENT REASSEMBLY TIME EXEEDED (1)\n");
				break;
				
				default:
				    printf("UNKNOWN CODE NUMBER: %d\n", icmph->code);
				    ald_print("UNKNOWN CODE NUMBER: %d (1)\n", icmph->code);
				break;
				
				}
			break;
			
			case 12:
			
			    switch(icmph->code){
			    
				case 0:
				    printf("Code: POINTER INDICATES THE ERROR (0)\n");
				    ald_print("Code: POINTER INDICATES THE ERROR (0)\n");
				break;
				
				case 1:
				    printf("Code: MISING A REQUIRED OPTION (1)\n");
				    ald_print("Code: MISSING A REQUIRED OPTION (1)\n");
				break;
				
				case 2:
				    printf("Code: BAD LENGTH (2)\n");
				    ald_print("Code: BAD LENGTH (2)\n");
				break;
				
				default:
				    printf("UNKNOWN CODE NUMBER: %d\n", icmph->code);
				    ald_print("UNKNOWN CODE NUMBER: %d\n", icmph->code);
				}
			break;
			    }
			
		}
	
		    printf("Checksum: 0x%x\n",ntohs(icmph->checksum));
		    ald_print("Checksum: 0x%x\n", ntohs(icmph->checksum));
		    
		    
		    printf("Packet content (analysed):\n");
		    ald_print("Packet content (analysed):\n");

	    
	    if(icmph->type==0 || icmph->type==8){
		
		tv=(struct timeval*)(payload);
		
	
	    printf("Seconds: %ld\n", tv->tv_sec);
	    ald_print("Seconds: %ld\n", tv->tv_sec);
	    
	    printf("Microseconds: %ld\n", tv->tv_usec);
	    ald_print("Microseconds: %ld\n", tv->tv_usec);    
	    
	}
	
	    if(icmph->type==17 || icmph->type==18){
	    
		mask=(struct in_addr*)(payload);
		printf("Network mask: %s\n", inet_ntoa(*mask));
		ald_print("Network mask: %s\n", inet_ntoa(*mask));
	}
	
	    if(icmph->type==3 || icmph->type==11 || icmph->type==12){
		temp=opt.size;
		temp2=pph->len;
		
		opt.size=0;
		pph->len=payload_len;
		
		parse_ip(payload, pph);
		opt.size=temp;
		pph->len=temp2;
		
	}
	
	printf("--end-of-icmp-packet--\n\n");
	ald_print("--end-of-icmp-packet--\n\n");
	
	
    return;
    
    
}	
	
    			
