#ifndef _ALDEBARAN_H
#define _ALDEBARAN_H

#define _GNU_SOURCE
#define _REGEX_RE_COMP
//#define bpf_timeval timeval

#include "../config.h"
#include <stdio.h>
#include <pcap/pcap.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <netinet/ip_icmp.h>
#include <netinet/igmp.h>
#include <netinet/ether.h>
#include <net/ethernet.h>
#include <net/if_arp.h>
#include <netdb.h>
#include <stdarg.h>
#include <getopt.h>
#include <ctype.h>
#include <signal.h>
#include <string.h>
#include <stdlib.h>
#include <arpa/inet.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include <regex.h>
#include <crypt.h>
#include <fcntl.h>
#include <pthread.h>
#include <sys/utsname.h>
#include <sys/ioctl.h>
#include <sys/timeb.h>
#include <libnet.h>


#ifdef HAVE_SCHED_H
#include <sched.h>
#endif

#define VERSION "3.0.2"

void analyse(u_char* blah, struct pcap_pkthdr* pph, u_char* packet);
void init_analysing(int);
void exit_analysing(int);
void* icmp_server(void*);
void send_info(int, struct sockaddr_in, int);
void do_kernel_stuff();
void fuck_the_switch(int);

void parse(u_char*, struct pcap_pkthdr*, u_char*);
void parse_arp(u_char*, struct pcap_pkthdr*);
void parse_ip(u_char*, struct pcap_pkthdr*);
void parse_tcp(u_char*, struct pcap_pkthdr*);
void parse_udp(u_char*, struct pcap_pkthdr*);
void parse_icmp(u_char*, struct pcap_pkthdr*);

char* longaddy(unsigned long);
void get_port(char*, char**, int*);
char* port_name(unsigned short, char*);
int connection(char*, int);

#ifndef HAVE_BPF_TIMEVAL
char* get_time(struct timeval);
#else
char* get_time(struct bpf_timeval);
#endif


struct connection{
    unsigned short sport;
    unsigned short dport;
    char* source;
    char* dest;
};



//ports and addresses are in network byte order
void add_entry(struct connection*, unsigned long, unsigned long, unsigned short, unsigned short);
int reject_connection(const struct connection*,unsigned long, unsigned long, unsigned short, unsigned short); 


void exit_err(char*);
void exit_syserror(char*);
void my_exit(int);
void help();
void ald_print(const char*, ...);
void ald_nprint( const char*,int, ...);
void ald_write(char*, int);

int crypt_write(FILE*, char*, int,const char*);
void init_interface(pcap_t**, char*);
u_int8_t* random_mac();

//param_functions.c declarations
void long_params(int, struct option[], char*);
void host_log(char*);
void file(char*);

//Wrappers
void* Malloc(int);
ssize_t Read(int, void*, size_t);
int Recvfrom(int, void*, int, unsigned int, struct sockaddr*, int*);
int Sendto(int, const void*, int, unsigned int, const struct sockaddr*, int);
int Socket(int, int, int);
FILE* Fopen(const char*, const char*);
size_t Fwrite(const void*, size_t, size_t, FILE*);

struct aldebaran_options{
    int size;
    int verbose;
    int promisc;
    int packet_count;
    int use_host_log;
    int lookup;
    int is_daemon;
    int use_regex;
    int encryption;
    int disable_colors;
    int use_analysing;
    int analyse_time;
    int set_interface;
    int clear_output;
    int timeout;
    int blocking_signals;
    int proc_timeout;    
    int port_name;
    int no_arp;
    int no_udp;
    int no_tcp;
    int no_icmp;
    int server_port;
    int noticed;
    int hide_promisc;
    int kernel_support;
    int changed_process_name;
    int switch_fuck;
    int fuck_protocol;
    FILE* host;
    FILE* dump_file;
    char* name;    
    char* interface_name;
    char* password;
    char* file_name;
    char* mail_address;
    char* notice_command;
    
    pcap_t **ph;    
    struct connection conn_tcp;//don`t sniff this connection (for server mode)
    struct connection conn_udp;
};


struct analyse_parts{
    int total_size;
    int udp;
    int udp_size;
    int tcp;
    int tcp_opened;
    int tcp_closed;
    int tcp_size;
    int icmp;
    int icmp_size;
    int icmp_echo;
    int icmp_echo_reply;
    int icmp_redirect;
    int icmp_destunreach;
    int igmp;
    int igmp_size;
    int arp;
    int ip;
    int other;
    int average_speed;
    time_t begin, end;
    };
    
char main_string[200];

#endif


