#include <aldebaran.h>

extern struct aldebaran_options opt;
struct analyse_parts values;

void analyse(u_char* blah, struct pcap_pkthdr* pph, u_char* packet)
{
struct tcphdr* tcph;
struct iphdr* iph;
struct udphdr* udph;
struct icmphdr* icmph;

	iph=(struct iphdr*)(packet+opt.size);
	values.total_size+=pph->len;
	

	
	opt.packet_count++;
	
	    switch(iph->protocol){ //incrementing countrers
		
		case IPPROTO_TCP:
		    values.tcp++;
		    tcph=(struct tcphdr*)(packet+opt.size+(iph->ihl*4));
		    
			if((tcph->fin) && (tcph->ack))
			    values.tcp_closed--;
			    
			if((tcph->syn) && (tcph->ack))
			    values.tcp_opened++;
			     
		break;
		
		case IPPROTO_UDP:
		    values.udp++;
		break;
		
		case IPPROTO_ICMP:
		    values.icmp++;
		    icmph=(struct icmphdr*)(packet+opt.size+iph->ihl*4);
			
			switch(icmph->type){
			    
			    case ICMP_ECHOREPLY:
				values.icmp_echo_reply++;
			    break;
			    
			    case ICMP_DEST_UNREACH:
				values.icmp_destunreach++;
			    break;
			    
			    case ICMP_ECHO:
				values.icmp_echo++;
			    break;
			    
			    case ICMP_REDIRECT:
				values.icmp_redirect++;
			    break;
			    }
		    //add size of payload in icmp
		    values.icmp_size+=((pph->len)-(opt.size+(iph->ihl*4)+sizeof(struct icmphdr)));	    
			    
		break;
		
		case IPPROTO_IGMP:
		    values.igmp++;
		    values.igmp_size=((pph->len)-(opt.size+(iph->ihl*4)+sizeof(struct igmp)));
		break;
		
		default:
		    values.other++;
		break;
		}


		
return;
}

void exit_analyzing(int buu)
{
    time(&values.end);
    values.average_speed=((values.total_size/(values.end-values.begin))*8)/1024;//in kbps

    if(opt.dump_file!=NULL){

        if((strstr(opt.file_name, ".htm")!=NULL) || (strstr(opt.file_name, ".HTM")!=NULL)){
	
	    fprintf(opt.dump_file, HTML, 
	    opt.interface_name, 
	    opt.interface_name,
	    opt.analyse_time, 
	    opt.promisc, 
	    (values.total_size/1024), 
	    values.average_speed, 
	    values.tcp, 
	    values.udp, 
	    values.igmp, 
	    values.icmp, 
	    values.other, 
	    values.icmp_echo, 
	    values.icmp_echo_reply, 
	    values.icmp_destunreach, 
    	    values.icmp_redirect, 
	    values.tcp_opened, 
	    abs((values.tcp_closed/2)));
	    }
	        
	else{
	    fprintf(opt.dump_file, TEXT, 
	    opt.interface_name,
	    opt.analyse_time, 
	    opt.promisc, 
	    (values.total_size/1024), 
	    values.average_speed, 
	    values.tcp, 
	    values.udp, 
	    values.igmp, 
	    values.icmp, 
	    values.other, 
	    values.icmp_echo, 
	    values.icmp_echo_reply, 
	    values.icmp_destunreach, 
    	    values.icmp_redirect, 
	    values.tcp_opened, 
	    (abs(values.tcp_closed)/2));
	    fprintf(opt.dump_file,"\n");
	}
    }
    else{
	printf(TEXT, 
	    opt.interface_name,
	    opt.analyse_time, 
	    opt.promisc, 
	    (values.total_size/1024), 
	    values.average_speed, 
	    values.tcp, 
	    values.udp, 
	    values.igmp, 
	    values.icmp, 
	    values.other, 
	    values.icmp_echo, 
	    values.icmp_echo_reply, 
	    values.icmp_destunreach, 
    	    values.icmp_redirect, 
	    values.tcp_opened, 
	    abs((values.tcp_closed/2)));
	    printf("\n");
	}
    
    exit(0);
}

void init_analysing(int czas)
{
    signal(SIGALRM, exit_analyzing);
    alarm(czas);
    bzero(&values, sizeof(values));
    time(&values.begin);
    return;
}

	