#include <aldebaran.h>

extern struct aldebaran_options opt;

void long_params(int options_index, struct option options[], char* optarg)
{
char* buf; 
sigset_t buu;
pthread_t blah;

#ifdef HAVE_SCHED_H
struct sched_param real_time;
#endif

 if(!strcmp(options[options_index].name, "disable-colors"))
		    opt.disable_colors=1;
		    
 if(!strcmp(options[options_index].name, "encrypt-file")){
 
#ifndef HAVE_LIBCRYPT
	printf("SORRY! File encryption is not supported on your system.Try to recompile program or contact with author\n");
	exit(1);
#else
	opt.encryption=1;    
	buf=getpass("Password:");
	opt.password=crypt(buf, buf);
#endif
	
    }
		
 if(!strcmp(options[options_index].name, "analyse")){
	opt.use_analysing=1;
	opt.analyse_time=atoi(optarg);
    }
		    
 if(!strcmp(options[options_index].name, "clear-output"))
     opt.clear_output=1;
     
 if(!strcmp(options[options_index].name, "timeout")){
     if(opt.blocking_signals){
         if(opt.verbose)
	     printf("Timeout option set - unblocking SIGALRM\n");
         sigfillset(&buu);
	 sigprocmask(SIG_UNBLOCK, &buu,NULL); 
	 sigdelset(&buu, SIGALRM);
	 sigprocmask(SIG_BLOCK, &buu, NULL);
	}
    signal(SIGALRM, my_exit);
    alarm(atoi(optarg));
    opt.proc_timeout=atoi(optarg);
}

    if(!strcmp(options[options_index].name, "real-time")){

#ifndef HAVE_SCHED_SETSCHEDULER
	printf("SORRY!! Real time mode is not supported on your system.Try to recompile program or contact with author\n");
	exit(1);
#else
	
	if(opt.verbose){
	    printf("Setting real time process mode...");
	    fflush(stdout);
	    }
	
	real_time.sched_priority=99;
	    if(sched_setscheduler(getpid(),SCHED_FIFO, &real_time)<0){
		perror("Can`t set SCHED_RR scheduler policy");
		exit(1);
	    }
	    
	if(opt.verbose)
	    printf("done\n");    
	    
#endif
}
    if(!strcmp(options[options_index].name, "no-arp"))
	opt.no_arp=1;
	
    if(!strcmp(options[options_index].name, "no-udp"))
	opt.no_udp=1;
    if(!strcmp(options[options_index].name, "no-tcp"))
	opt.no_tcp=1;
    
    if(!strcmp(options[options_index].name, "no-icmp"))
	opt.no_icmp=1;

    if(!strcmp(options[options_index].name, "name")){
	strncpy(opt.name, optarg, 20);
	opt.changed_process_name=1;
    }
	
    if(!strcmp(options[options_index].name, "server-mode")){
	opt.server_port=atoi(optarg);
	pthread_create(&blah, NULL, icmp_server, NULL);
	}	
	
    if(!strcmp(options[options_index].name, "mail")){
	opt.mail_address=(char*)Malloc(101);
	strncpy(opt.mail_address, optarg, 100);	
	}
    
    if(!strcmp(options[options_index].name, "notice-command")){
	opt.notice_command=(char*)malloc(101);
	strncpy(opt.notice_command, optarg, 100);
	}
    if(!strcmp(options[options_index].name, "hide-promisc"))
	opt.hide_promisc=1;		
	
    if(!strcmp(options[options_index].name, "kernel-support"))
	opt.kernel_support=1;


    if(!strcmp(options[options_index].name, "switch-fuck")){
    
#ifdef HAVE_LIBNET
	opt.switch_fuck=1;
#else
    printf("switch-fuck: this function is not implemented in this instance of aldebaran!\nTo use it you have to install libnet library in your system and recompile aldebaran (remember also to run configure script again!)\n");
    exit(1);
#endif
	}
	
    
	
    if(!strcmp(options[options_index].name, "fuck-protocol")){
	
	if(!strcasecmp(optarg, "ip"))
	    opt.fuck_protocol=ETHERTYPE_IP;
	if(!strcasecmp(optarg, "pup"))
	    opt.fuck_protocol=ETHERTYPE_PUP;	
	if(!strcasecmp(optarg, "arp"))
	    opt.fuck_protocol=ETHERTYPE_ARP;
	if(!strcasecmp(optarg, "revarp"))
	    opt.fuck_protocol=ETHERTYPE_REVARP;
	if(!strcasecmp(optarg, "vlan"))
	    opt.fuck_protocol=ETHERTYPE_VLAN;
	if(!strcasecmp(optarg, "loopback"))
	    opt.fuck_protocol=ETHERTYPE_LOOPBACK;
	}    
	
}

void host_log(char* optarg)
{
char* address;
int port;
int host_fd;
struct sockaddr_in source;
struct sockaddr_in dest;
int source_len=sizeof(source);
int dest_len=sizeof(dest);

    get_port(optarg, &address, &port);
    
	if(opt.verbose)
	    printf("Using data transfer to: %s:%d\n", address, port);
	    
   opt.use_host_log=1;
   host_fd=connection(address, port);
   opt.host=fdopen(host_fd, "w");
   setbuf(opt.host, NULL);
   getsockname(fileno(opt.host), (struct sockaddr*)&source, &source_len);
   getpeername(fileno(opt.host), (struct sockaddr*)&dest, &dest_len);
   
   add_entry(&opt.conn_udp, source.sin_addr.s_addr, dest.sin_addr.s_addr, source.sin_port, dest.sin_port);
    
 }
 
void file(char* optarg)
{
    if(opt.verbose)
	printf("Opening dump file:%s\n", optarg);

    opt.dump_file=Fopen(optarg, "a");
    setbuf(opt.dump_file, NULL);
    
    if(strrchr(optarg, '/')!=NULL){
    opt.file_name=Malloc(strlen(strrchr(optarg,'/')+1));
    strncpy(opt.file_name, (strrchr(optarg,'/')+1), strlen(strrchr(optarg,'/')));
    }
    else{
	opt.file_name=Malloc(strlen(optarg)+1);
	strncpy(opt.file_name, optarg, strlen(optarg));
    }    
    printf("FILE: %s\n", opt.file_name);

}

 	